#!/bin/sh
#
#  Copyright (c) 1992, Raphael Manfredi
#
#  You may redistribute only under the terms of the GNU General Public
#  Licence as specified in the README file that comes with dist.
#
# $Id: chkagent.sh,v 2.9 92/07/14 16:47:41 ram Exp $
#
# $Log:	chkagent.sh,v $
# Revision 2.9  92/07/14  16:47:41  ram
# 3.0 beta baseline.
# 

# Make sure the mailagent is working well
lookat='ERROR|FAILED|WARNING|FATAL|DUMPED'

trap "rm -f $report $output $todaylog $msg" 1 2 3 15

# Interpret the ~/.mailagent configuration file
set X `<$HOME/.mailagent sed -n \
	-e '/^[ 	]*#/d' \
	-e 's/^[ 	]*\([^ 	:\/]*\)[ 	]*:[ 	]*\([^#]*\).*/\1="\2";/p'`
shift

# Deal with possible white spaces in variables and ~ substitution
cmd=''
for line in $*; do
	cmd="$cmd$line"
done
cmd=`echo $cmd | sed -e "s|~|$HOME|g"`
eval $cmd

# Compute location of report file and log file
report="/tmp/cAg$$"
output="/tmp/cAo$$"
logfile="$logdir/$log"
todaylog="/tmp/tAg$$"

# Current date format to look for in logfile
today=`date "+%y/%m/%d"`

if test -f "$logfile"; then
	grep "$today" $logfile > $todaylog
	egrep "$lookat" $todaylog > $output
	if test -s "$output"; then
		echo "*** Errors from logfile ($logfile):" > $report
		echo " " >> $report
		cat $output >> $report
	fi
	rm -f $todaylog $output
else
	echo "Cannot find $logfile" > $report
fi

# ~/.bak is the output from .forward
if test -s "$HOME/.bak"; then
	echo " " >> $report
	echo "*** Errors from ~/.bak:" >> $report
	echo " " >> $report
	cat $HOME/.bak >> $report
	cp /dev/null $HOME/.bak
fi

# Look for mails in the emergency directory
ls -C $emergdir > $output
if test -s "$output"; then
	echo " " >> $report
	echo "*** Mails held in lost+mail ($emergdir):" >> $report
	echo " " >> $report
	cat $output >> $report
fi
rm -f $output

# Spot any unprocessed mails in the queue
cd $queue
ls -C qm* fm* > $output 2>/dev/null
if test -s "$output"; then
	echo " " >> $report
	echo "*** Unprocessed mails in queue ($queue):" >> $report
	echo " " >> $report
	cat $output >> $report
fi
rm -f $output

if test -s "$report"; then
	msg="/tmp/mAg$$"
	cat >$msg <<EOM
To: $user
Subject: Errors from mailagent system

EOM
	cat $report >>$msg
	rm -f $report
	/usr/lib/sendmail -odi -t <$msg
	rm -f $msg
else
	rm -f $report
fi

exit 0
