/*

 #    #   ####    ####            ####
 ##  ##  #       #    #          #    #
 # ## #   ####   #               #
 #    #       #  #  ###   ###    #
 #    #  #    #  #    #   ###    #    #
 #    #   ####    ####    ###     ####

	Fatal messages.
*/

/*
 * $Id: msg.c,v 2.9 92/07/14 16:48:32 ram Exp $
 *
 *  Copyright (c) 1992, Raphael Manfredi
 *
 *  You may redistribute only under the terms of the GNU General Public
 *  Licence as specified in the README file that comes with dist.
 *
 * $Log:	msg.c,v $
 * Revision 2.9  92/07/14  16:48:32  ram
 * 3.0 beta baseline.
 * 
 */

#include "config.h"
#include "portable.h"
#include <stdio.h>
#include <sys/types.h>
#include "sysexits.h"
#include "logfile.h"
#include "lock.h"
#include "io.h"

#define MAX_STRING	1024		/* Maximum length for error string */

/* VARARGS2 */
public void fatal(reason, arg1, arg2, arg3, arg4, arg5)
char *reason;
int arg1, arg2, arg3, arg4, arg5;
{
	/* Fatal error -- die with a meaningful error status for sendmail. If the
	 * logfile has been opened, the reason will also be logged there.
	 */
	char buffer[MAX_STRING];
	int status;						/* Status from emergency_save() */
	
	status = emergency_save();		/* Attempt emergency saving */

	fprintf(stderr, "%s: ", progname);
	fprintf(stderr, reason, arg1, arg2, arg3, arg4, arg5);
	fputc('\n', stderr);
	sprintf(buffer, "FATAL %s", reason);
	add_log(1, buffer, arg1, arg2, arg3, arg4, arg5);
	release_lock();

	if (!was_queued()) {
		add_log(6, "NOTICE leaving mail in MTA's queue");
		exit(EX_TEMPFAIL);
	} else if (status == -1) {
		add_log(5, "WARNING no saving was ever done");
		add_log(6, "NOTICE leaving mail in MTA's queue");
		exit(EX_TEMPFAIL);
	}

	exit(EX_OK);
}

