case $CONFIG in
'')
	if test ! -f config.sh; then
		ln ../config.sh . || \
		ln ../../config.sh . || \
		ln ../../../config.sh . || \
		(echo "Can't find config.sh."; exit 1)
	fi 2>/dev/null
	. config.sh
	;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting agent/magent (with variable substitutions)"
$spitshell >magent <<!GROK!THIS!
# feed this into perl
	eval 'exec perl -S \$0 "\$@"'
		if \$running_under_some_shell;

# You'll need to set up a .forward file that feeds your mail to this script,
# via the filter. Mine looks like this:
#   "|exec /users/ram/mail/filter >>/users/ram/.bak 2>&1"

# $Id: magent.SH,v 2.9 92/07/14 16:48:48 ram Exp $
#
#  Copyright (c) 1991, 1992, Raphael Manfredi
#
#  You may redistribute only under the terms of the GNU General Public
#  Licence as specified in the README file that comes with dist.
#
# $Log:	magent.SH,v $
# Revision 2.9  92/07/14  16:48:48  ram
# 3.0 beta baseline.
# 

# Perload ON

# The following were determined by Configure
\$phostname = '$phostname';			# Command used to compute hostname
\$mydomain = '$mydomain';			# Our domain name
\$hiddennet = '$hiddennet';			# Hidden network (advertised host)
\$maildir = '$maildir';				# Directory where mail is spooled
\$mailfile = '$mailfile';			# File in which mail is stored
\$mversion = '$VERSION';			# Current version number
\$patchlevel = '$PATCHLEVEL';		# And patchlevel from patchlevel.h
\$lock_by_flock = '$lock_by_flock';	# Want to lock mailboxes with flock ?
\$flock_only = '$flock_only';		# Only use flock() and no .lock file
\$orgname = '$orgname';				# Our organization name
\$inews = '$inews';
!GROK!THIS!

$spitshell >>magent <<'!NO!SUBS!'

$prog_name = $0;				# Who I am
$prog_name =~ s|^.*/(.*)|$1|;	# Keep only base name
$has_option = 0;				# True if invoked with options
$config_file = '~/.mailagent';	# Default configuration file
$log_level = -1;				# Changed by -L option

# Calling the mailagent as 'mailqueue' lists the queue
if ($prog_name eq 'mailqueue') {
	++$list_queue;
	++$has_option;
}

# Parse options
while ($ARGV[0] =~ /^-/) {
	$_ = shift;
	last if /--/;
	if ($_ eq '-c') {		# Specify alternate configuration file
		$config_file = shift;
	}
	elsif ($_ eq '-d') {	# Dump rules
		++$has_option;		# Incompatible with other special options
		++$dump_rule;
	}
	elsif ($_ eq '-e') {	# Rule supplied on command line
		local($*) = 1;
		$_ = shift;
		s/\n/ /g;
		push(@Linerules, $_);
		++$edited_rules;	# Signals rules came from command line
	}
	elsif ($_ eq '-f') {	# Take messages from UNIX mailbox
		++$mbox_mail;
		$mbox_file = shift;	# -f followed by file name
	}
	elsif ($_ eq '-h') {	# Usage help
		&usage;
	}
	elsif ($_ eq '-i') {	# Interactive mode: log messages also on stderr
		*add_log = *stderr_log;
	}
	elsif ($_ eq '-l') {	# List queue
		++$has_option;		# Incompatible with other special options
		++$list_queue;
		++$norule;			# No need to compile rules
	}
	elsif ($_ eq '-o') {	# Overwrite configuration variable
		$over_config .= "\n" . shift;
	}
	elsif ($_ eq '-q') {	# Process the queue
		++$has_option;		# Incompatible with other special options
		++$run_queue;
	}
	elsif ($_ eq '-r') {	# Specify alternate rule file
		$rule_file = shift;
	}
	elsif (/^-s(\S*)/) {	# Print statistics
		++$has_option;		# Incompatible with other special options
		++$stats;
		++$norule;			# No need to compile rules
		$stats_opt = $1;
	}
	elsif ($_ eq '-t') {	# Track rule matches on stdout
		++$track_all;
	}
	elsif ($_ eq '-L') {	# Specify new logging level
		$log_level = int(shift);
	}
	elsif ($_ eq '-V') {	# Version number
		print STDERR "$prog_name $mversion PL$patchlevel\n";
		exit 0;
	}
	else {
		print STDERR "$prog_name: unknown option: $_\n";
		&usage;
	}
}

# Only one option at a time (among those options which change our goal)
if ($has_option > 1) {
	print STDERR "$prog_name: at most one special option may be specified.\n";
	exit 1;
}

$file_name = shift;				# File name to be processed (null if stdin)
$ENV{'IFS'}='' if $ENV{'IFS'};	# Shell separation field
&get_configuration;				# Get a suitable configuration package (cf)
select(STDOUT);					# Because the -t option writes on STDOUT,
$| = 1;							# make sure it is flushed before we fork()
$agent_wait = "agent.wait";		# Waiting file for out-of-the-queue mails

if ($orgname =~ m|^/|) {		# Name of organization kept in file
	unless (open(ORG, $orgname)) {
		&add_log("ERROR cannot read $orgname") if $loglvl;
	} else {
		chop($orgname = <ORG>);
		close ORG;
	}
}

$ENV{'HOME'} = $cf'home;
$ENV{'USER'} = $cf'user;
$ENV{'NAME'} = $cf'name;
$baselock = "$cf'spool/perl";	# This file does not exist
$lockext = ".lock";				# Extension used by lock routines
$fd = STDIN;					# Default imput file
$lockfile = $baselock . $lockext;

umask(077);						# Files we create are private ones
do get_jobnum();				# Compute a job number held in $jobnum

# Allow only ONE mailagent at a time (resource consumming)
do checklock($baselock);		# Make sure old locks do not remain
unless (-f $lockfile) {
	# Try to get the lock file (acting as a token). We do not need locking if
	# we have been invoked with an option and that option is not -q.
	if ($has_option && !$run_queue) {
		&add_log("no need to get a lock") if $loglvl > 19;
	} elsif (0 == &acs_rqst($baselock)) {
		&add_log("got the right to process mail") if $loglvl > 19;
		++$locked;
	} else {
		&add_log("denied right to process mail") if $loglvl > 19;
	}
}

if (!$locked && !$has_option) {
	# Another mailagent is running somewhere
	&queue_mail($file_name);
	exit 0;
}

# Initialize mail filtering and compile filter rule if necessary
&init_all;
&compile_rules unless $norule;

# If rules are to be dumped, this is the only action
if ($dump_rule) {
	&dump_rules(*print_rule_number, *void_func);
	unlink $lockfile if $locked;
	exit 0;
}

# Likewise, statistics dumping is the only option
if ($stats) {
	&report_stats($stats_opt);
	unlink $lockfile if $locked;
	exit 0;
}

# Listing the queue is also the only performed action
if ($list_queue) {
	&list_queue;
	unlink $lockfile if $locked;
	exit 0;
}

# Taking messages from mailbox file
if ($mbox_mail) {
	++$run_queue if 0 == &mbox_mail($mbox_file);
	unless ($run_queue) {
		unlink $lockfile if $locked;
		exit 1;		# -f failed
	}
	&add_log("processing queued mails") if $loglvl > 15;
}

&read_stats;	# Get statistics, so that we may update them in memory

if (!$run_queue) {				# Do not enter here if -q
	if (0 != &analyze_mail($file_name)) {	# Analyze the mail
		do add_log("ERROR while processing main message--queing it")
			if ($loglvl > 0);
		do queue_mail($file_name);
		unlink $lockfile;
		exit 0;					# Do not continue
	} else {
		$file = $file_name;		# Never corrupt $file_name
		$file =~ s|.*/(.*)|$1|;	# Keep only basename
		$file = "<stdin>" if $file eq '';
		do add_log("FILTERED [$file] $Header{'Length'} bytes") if $loglvl > 4;
	}
}

# Fork a child: we have to take care of the filter script which is waiting for
# us to finish processing of the delivered mail.
do fork_child() unless $run_queue;

# From now on, we are in the child process... Don't sleep at all if logging
# level is greater that 11 or if $run_queue is true. Logging level of 12 and
# higher are for debugging and should not be used on a permanent basis anyway.

$sleep = 1;					# Give others a chance to queue their mail
$sleep = 0 if $loglvl > 11 || $run_queue;

while (do pqueue()) {			# Eventually process the queue
	sleep 30 if $sleep;			# Wait in case new mail arrives
}

# End of mailagent processing
&write_stats;					# Resynchronizes the statistics file
&contextual_operations;			# Perform all the contextual operations
&add_log("mailagent exits") if $loglvl > 17;
unlink $lockfile if $locked;
exit 0;

# Print usage and exit
sub usage {
	print STDERR <<EOF;
Usage: $prog_name [-dhilqtV] [-s{umary}] [-f file] [-e rules] [-c config]
       [-L level] [-r file] [-o def] [mailfile]
  -c : specify alternate configuration file.
  -d : dump filter rules (special).
  -e : enter rules to be applied.
  -f : get messages from UNIX-style mailbox file.
  -h : print this help message and exits.
  -i : interactive usage -- print log messages on stderr.
  -l : list message queue (special).
  -L : force logging level.
  -o : overwrite config file with supplied definition.
  -q : process the queue (special).
  -r : sepcify alternate rule file.
  -s : report gathered statistics (special).
  -t : track rules on stdout.
  -V : print version number and exits.
EOF
	exit 1;
}

# Read configuration file and alter it with the values specified via -o.
# Then apply -r and -t by modifying suitable configuration parameters.
sub get_configuration {
	&read_config($config_file);		# Read configuration file and set vars
	&cf'parse($over_config);		# Overwrite with command line options
	$cf'rules = $rule_file if $rule_file;		# -r overwrites rule file
	$loglvl = $log_level if $log_level >= 0;	# -L overwrites logging level
}

#
# The filtering routines
#

# Start-up initializations
sub init_all {
	do init_signals();		# Trap common signals
	do init_constants();	# Constants definitions
	do init_interpreter();	# Initialize tables %Priority, %Function, ...
	do init_env();			# Initialize the %XENV array
	do init_matcher();		# Initialize special matching functions
	do init_pseudokey();	# Initialize the pseudo header keys for H table
	do init_builtins();		# Initialize built-in commands like @RR
	do init_filter();		# Initialize filter commands
	do init_special();		# Initialize special user table %Special
}

# Protect ourselves (trap common signals)
sub init_signals {
	$SIG{'HUP'} = 'emergency';
	$SIG{'INT'} = 'emergency';
	$SIG{'QUIT'} = 'emergency';
	$SIG{'PIPE'} = 'emergency';
	$SIG{'IO'} = 'emergency';
	$SIG{'BUS'} = 'emergency';
	$SIG{'ILL'} = 'emergency';
	$SIG{'SEGV'} = 'emergency';
	$SIG{'ALRM'} = 'emergency';
	$SIG{'TERM'} = 'emergency';
}

# Constants definitions
sub init_constants {
	require 'ctime.pl';
	# Values for flock(), usually in <sys/file.h>
	$LOCK_SH = 1;				# Request a shared lock on file
	$LOCK_EX = 2;				# Request an exclusive lock
	$LOCK_NB = 4;				# Make a non-blocking lock request
	$LOCK_UN = 8;				# Unlock the file

	# Status used by filter
	$FT_RESTART = 0;			# Abort current action, restart from scratch
	$FT_CONT = 1;				# Continue execution
	$FT_REJECT = 2;				# Abort current action, continue filtering
	$FT_ABORT = 3;				# Abort filtering process

	# Shall we append or remove folder?
	$FOLDER_APPEND = 0;			# Append in folder
	$FOLDER_REMOVE = 1;			# Remove folder

	# Used by shell_command and children
	$NO_INPUT = 0;				# No input (stdin is closed)
	$BODY_INPUT = 1;			# Give body of mail as stdin
	$MAIL_INPUT = 2;			# Pipe the whole mail
	$HEADER_INPUT = 3;			# Pipe the header only
	$NO_FEEDBACK = 0;			# No feedback wanted
	$FEEDBACK = 1;				# Feed result of command back into %Header
	
	# The filter message
	local($address) = &email_addr;
	$FILTER =
		"X-Filter: mailagent [version $mversion PL$patchlevel] for $address";

	# For header fields alteration
	$HD_STRIP = 0;				# Strip header fields
	$HD_KEEP = 1;				# Keep header fields

	# Faked leading From line (used for digest items, by SPLIT)
	local($now) = &ctime(time);
	chop($now);
	$FAKE_FROM = "From mailagent " . $now;
}

# Initializes environment. All the variables are initialized in XENV array
# The sole purpose of XENV is to be able to know what changes wrt the invoking
# environment when dumping the rules. It also avoid modifying the environment
# for our children.
sub init_env {
	foreach (keys(%ENV)) {
		$XENV{$_} = $ENV{$_};
	}
}

# List of special header keys which do not represent a true header field.
sub init_pseudokey {
	%Pseudokey = (
		'Body', 1,
		'Head', 1,
		'All', 1
	);
}

#
# Miscellaneous utilities
#

# Attempts a mailbox locking. The argument is the name of the file, the file
# descriptor is the global MBOX, opened for appending.
sub mbox_lock {
	local($file) = @_;				# File name
	unless ($flock_only) {			# Lock with .lock
		if (0 != &acs_rqst($file)) {
			do add_log("WARNING could not lock $file") if $loglvl > 5;
		}
	}
	# Make sure the file is still there and as not been removed while we were
	# waiting for the lock (in which case our MBOX file descriptor would be
	# useless: we would write in a ghost file!). This could happen when 'elm'
	# (or other mail user agent) resynchronizes the mailbox.
	close MBOX;
	if (open(MBOX, ">>$file")) {
		if ($lock_by_flock) {
			unless (eval 'flock(MBOX, $LOCK_EX)') {	# Ask for exclusive lock
				do add_log("WARNING could not flock $file: $!") if $loglvl > 5;
			}
		}
	} else {
		do fatal("could not reopen $file");
	}
	seek(MBOX, 0, 2);				# Someone may have appended something
}

# Remove lock on mailbox
sub mbox_unlock {
	local($file) = @_;				# File name
	close MBOX;						# Closing will remove flock lock
	&free_file($file) unless $flock_only;		# Remove the .lock
}

# Computes the e-mail address of the user
sub email_addr {
	$cf'user . '@' . &domain_addr;		# E-mail address in internet format
}

# Domain name address for current host
sub domain_addr {
	local($_);							# Our host name
	$_ = $hiddennet if $hiddennet ne '';
	if ($_ eq '') {
		chop($_ = `$phostname`);		# Must fork to get hostname, grr...
		$_ .= $mydomain unless /\./;	# We want something fully qualified
	}
	$_;
}

# Compute the system mailbox file name
sub mailbox_name {
	# If ~/.mailagent provides us with a mail directory, use it and possibly
	# override value computed by Configure.
	$maildir = $cf'maildrop if $cf'maildrop ne '';
	# If Configure gave a valid 'maildir', use it. Otherwise compute one now.
	unless ($maildir ne '' && -d "$maildir") {
		$maildir = "/usr/spool/mail";		# Default spooling area
		-d "/usr/mail" && ($maildir = "/usr/mail");
		-d "$maildir" || ($maildir = "$cf'home");
	}
	$mailbox = "$maildir/$cf'user";
	if (! -f "$mailbox" && ! -w "$maildir") {
		# No mailbox already exists and we can't write in the spool directory.
		# Use mailfile then, and if we can't write in the directory and the
		# mail file does not exist either, use ~/mbox.$cf'user as mailbox.
		$mailbox = $mailfile;		# Determined by configure (%~ and %L form)
		$mailbox =~ s/%~/$cf'home/go;	# %~ stands for the user directory
		$mailbox =~ s/%L/$cf'user/go;	# %L stands for the user login name
		$mailbox =~ m|(.*)/.*|;			# Extract dirname
		$mailbox = "$cf'home/mbox.$cf'user" unless (-f "mailbox" || -w "$1");
		do add_log("WARNING using $mailbox for mailbox") if $loglvl > 5;
	}
	$mailbox;
}

# Fork a new mailagent and update the pid in the perl.lock file. The parent
# then exits and the child continues. This enables the filter which invoked
# us to finally exit.
sub fork_child {
	local($pid) = fork;
	if ($pid == -1) {				# We cannot fork, exit.
		do add_log("ERROR couldn't fork to process the queue") if $loglvl > 5;
		unlink $lockfile if $locked;
		exit 0;
	} elsif ($pid == 0) {			# The child process
		# Update the pid in the perl.lock file, so that any process which will
		# use the kill(pid, 0) feature to check whether we are alive or not will
		# get a meaningful status.
		if ($locked) {
			chmod 0644, $lockfile;
			open(LOCK, ">$lockfile");	# Ignore errors
			chmod 0444, $lockfile;		# Now it's open, so we may restore mode
			print LOCK "$$\n";			# Write child's PID
			close LOCK;
		}
		sleep(2);					# Give filter time to clean up
	} else {						# Parent process
		exit 0;						# Exit without removing lock, of course
	}
	# Only the child comes here and returns
	do add_log("mailagent continues") if $loglvl > 17;
}

# Computes a new job number
sub get_jobnum {
	if (0 != &acs_rqst($cf'seqfile)) {
		$jobnum = "?";
		do checklock($cf'seqfile);		# Check for old lock
	} else {
		local($njob);
		open(FILE, "$cf'seqfile");
		$njob = int(<FILE>);
		close FILE;
		$njob++;
		open(FILE, ">$cf'seqfile");
		print FILE "$njob\n";
		close FILE;
		$jobnum = "$njob";
		do free_file("$cf'seqfile");
	}
}

# Report any eval error
sub eval_error {
	if ($@ ne '') {
		$@ =~ s/ in file \(eval\) at line \d+//;
		chop($@);
		do add_log("ERROR $@") if $loglvl > 1;
	}
}

!NO!SUBS!
$grep -v '^;#' pl/read_conf.pl >>magent
$grep -v '^;#' pl/acs_rqst.pl >>magent
$grep -v '^;#' pl/free_file.pl >>magent
$grep -v '^;#' pl/add_log.pl >>magent
$grep -v '^;#' pl/checklock.pl >>magent
$grep -v '^;#' pl/lexical.pl >>magent
$grep -v '^;#' pl/analyze.pl >>magent
$grep -v '^;#' pl/runcmd.pl >>magent
$grep -v '^;#' pl/filter.pl >>magent
$grep -v '^;#' pl/matching.pl >>magent
$grep -v '^;#' pl/locate.pl >>magent
$grep -v '^;#' pl/rfc822.pl >>magent
$grep -v '^;#' pl/macros.pl >>magent
$grep -v '^;#' pl/header.pl >>magent
$grep -v '^;#' pl/actions.pl >>magent
$grep -v '^;#' pl/stats.pl >>magent
$grep -v '^;#' pl/queue_mail.pl >>magent
$grep -v '^;#' pl/pqueue.pl >>magent
$grep -v '^;#' pl/builtins.pl >>magent
$grep -v '^;#' pl/rules.pl >>magent
$grep -v '^;#' pl/period.pl >>magent
$grep -v '^;#' pl/eval.pl >>magent
$grep -v '^;#' pl/dbr.pl >>magent
$grep -v '^;#' pl/history.pl >>magent
$grep -v '^;#' pl/once.pl >>magent
$grep -v '^;#' pl/makedir.pl >>magent
$grep -v '^;#' pl/emergency.pl >>magent
$grep -v '^;#' pl/listqueue.pl >>magent
$grep -v '^;#' pl/mbox.pl >>magent
$grep -v '^;#' pl/context.pl >>magent
$grep -v '^;#' pl/getdate.pl >>magent
chmod 755 magent
$eunicefix magent
