case $CONFIG in
'')
	if test ! -f config.sh; then
		ln ../config.sh . || \
		ln ../../config.sh . || \
		ln ../../../config.sh . || \
		(echo "Can't find config.sh."; exit 1)
	fi 2>/dev/null
	. config.sh
	;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting agent/mailpatch (with variable substitutions)"
$spitshell >mailpatch <<!GROK!THIS!
# feed this into perl
	eval "exec perl -S \$0 \$*"
		if \$running_under_some_shell;

# $Id: mailpatch.SH,v 2.9 92/07/14 16:49:00 ram Exp $
#
#  Copyright (c) 1991, 1992, Raphael Manfredi
#
#  You may redistribute only under the terms of the GNU General Public
#  Licence as specified in the README file that comes with dist.
#
# $Log:	mailpatch.SH,v $
# Revision 2.9  92/07/14  16:49:00  ram
# 3.0 beta baseline.
# 

\$cat = '$cat';
\$zcat = '$zcat';
\$mversion = '$VERSION';
\$patchlevel = '$PATCHLEVEL';
!GROK!THIS!
$spitshell >>mailpatch <<'!NO!SUBS!'

$prog_name = $0;				# Who I am
$prog_name =~ s|^.*/(.*)|$1|;	# Keep only base name

do read_config();	# First, read configuration file (in ~/.mailagent)

# take job number and command from environment
# (passed by mailagent)
$jobnum = $ENV{'jobnum'};
$fullcmd = $ENV{'fullcmd'};
$pack = $ENV{'pack'};
$path = $ENV{'path'};

do read_dist();			# Read distributions

$dest = shift;			# Who should the patches be sent to
$system = shift;		# Which system do patches belong
$version = shift;		# Which version it is

# A single '-' as first argument stands for return path
$dest = $path if $dest eq '-';

# A single '-' for version means "highest available" version.
$version = $Version{$system} if $version eq '-';

# Full name of system for H table access
$pname = $system . "|" . $version;

$maillist = "To obtain a list of what is available, send me the following mail:

	Subject: Command
	@SH maillist $path
		^ note the l";

if (!$System{$system}) {
	open(MAILER, "|/usr/lib/sendmail -odq -t");
	print MAILER
"To: $path
Bcc: $cf'user
Subject: No program called $system
X-Mailer: mailagent [version $mversion PL$patchlevel]

I don't know how to send patches for a program called $system.  Sorry.

$maillist

If $cf'name can figure out what you meant, you'll get the patches anyway.

-- mailpatch speaking for $cf'user
";
	close MAILER;
    do add_log("FAILED (UNKNOWN SYSTEM)") if ($loglvl > 1);
    exit 0;
}

if (!$Program{$pname}) {
	open(MAILER, "|/usr/lib/sendmail -odq -t");
	print MAILER
"To: $path
Bcc: $cf'user
Subject: No patches for $system version $version
X-Mailer: mailagent [version $mversion PL$patchlevel]

I don't know how to send patches for version $version of $system.  Sorry.";
	if ($Version{$system} ne '') {
		print MAILER "

[The highest version for $system is $Version{$system}.]";
		do add_log("MSG highest version is $Version{$system}")
			if ($loglvl > 11);
	} else {
		print MAILER "

[There is no version number for $system.]";
		do add_log("MSG no version number") if ($loglvl > 11);
	}
	print MAILER "

$maillist

If $cf'name can figure out what you meant, you'll get the patches anyway.

-- mailpatch speaking for $cf'user
";
	close MAILER;
    do add_log("FAILED (BAD SYSTEM NUMBER)") if ($loglvl > 1);
    exit 0;
}

if (!($Maintained{$pname} || $Patches{$pname})) {
	open(MAILER, "|/usr/lib/sendmail -odq -t");
	print MAILER
"To: $path
Bcc: $cf'user
Subject: $system version $version is not maintained
X-Mailer: mailagent [version $mversion PL$patchlevel]

I can't send you patches for version $version of $system, because this code
is not maintained by $cf'name. There are no official patches available either...

$maillist

Anyway, if you discover a bug or have remarks about \"$system\", please
let me know. Better, if you know where patches for $system can be found,
well... you have my e-mail address ! :->

-- mailpatch speaking for $cf'user
";
	close MAILER;
    do add_log("FAILED (NOT MAINTAINED)") if ($loglvl > 1);
    exit 0;
}

# Create a temporary directory
$tmp = "$cf'tmpdir/dmp$$";
mkdir($tmp, 0700) || do fatal("cannot create $tmp");

# Need to unarchive the distribution
if ($Archived{$pname}) {
	# Create a temporary directory for distribution
	$tmp_loc = "$cf'tmpdir/dmpl$$";
	mkdir($tmp_loc, 0700) || do fatal("cannot create $tmp_loc");
	$Location{$pname} =
		do unpack($Location{$pname}, $tmp_loc, $Compressed{$pname});
}

# Go to bugs sub-directory. It is possible to ask for patches for
# old systems. Such systems are identified by having the `patches'
# field from the distrib file set to "old". In that case, patches
# are taken from a bugs-version directory. Version has to be non null.

if ($Patch_only{$pname}) {
	do abort("old system has no version number") if $version eq '';
	chdir "$Location{$pname}/bugs-$version" ||
		do abort("cannot go to $Location{$pname}/bugs-$version");
	# There is no patchlevel to look at -- compute by hand.
	for ($maxnum = 1; ; $maxnum++) {
		last unless -f "patch$maxnum" || -f "patch$maxnum.Z";
	}
	$maxnum--;		# We've gone too far
} else {
	chdir "$Location{$pname}/bugs" ||
		do abort("cannot go to $Location{$pname}/bugs");
	open(PATCHLEVEL, "../patchlevel.h") ||
		do abort("cannot open patchlevel.h");
	$maxnum = 0;
	while (<PATCHLEVEL>) {
		if (/.*PATCHLEVEL[ \t]*(\d+)/) {
			$maxnum = $1;
			last;
		}
	}
	close PATCHLEVEL;
}

if (!$maxnum) {
	# If we get here, it must be for one of our systems. Indeed,
	# if we do not have any patches for a third party program, there
	# should be a "no" in the patches field of distribution file, and
	# in that case an error would have been reported before.
	open(MAILER, "|/usr/lib/sendmail -odq -t");
	print MAILER
"To: $path
Bcc: $cf'user
Subject: No patches yet for $system version $version
X-Mailer: mailagent [version $mversion PL$patchlevel]

There are no patches (yet) for $system version $version. Sorry.

-- mailpatch speaking for $cf'user
";
	close MAILER;
    do add_log("FAILED (NO PATCHES YET)") if ($loglvl > 1);
	do clean_tmp();
    exit 0;
}

$patchlist = do rangeargs($maxnum, @ARGV);	# Generate patch list

if (! ($patchlist =~ /\d/)) {
	open(MAILER, "|/usr/lib/sendmail -odq -t");
	print MAILER
"To: $path
Bcc: $cf'user
Subject: Invalid patch request for $system $version
X-Mailer: mailagent [version $mversion PL$patchlevel]
";
	if ($Patches{$pname}) {
		print MAILER "
The highest patch I have for $system version $version is #$maxnum.";
	} else {
		print MAILER "
The latest patch for $system version $version is #$maxnum.";
	}
	print MAILER "
(Your command was: $fullcmd)";
	if ($Version{$system} > $version) {
		print MAILER "

Please note that the latest version for $system is $Version{$system}.

$maillist";
	}
	print MAILER "

-- mailpatch speaking for $cf'user
";
	close MAILER;
    do add_log("FAILED (INVALID PATCH LIST)") if ($loglvl > 1);
	do clean_tmp();
    exit 0;
}

@numbers = split(/ /,$patchlist);

foreach $num (@numbers) {
	$patchfile = "patch" . $num;	# Base name of the patch
	if (-f $patchfile) {			# Normal patch
		$append = $cat;
		$extent = '';
	} elsif (-f "$patchfile.Z") {	# Compressed patch
		if ($zcat ne 'zcat') {		# Zcat found by Configure
			$append = $zcat;
			$extent = '.Z';
		} else {
			do add_log("ERROR no zcat to uncompress patch #$num ($system)")
				if ($loglvl > 5);
			next;
		}
	} else {
		do add_log("ERROR no patch #$num ($system)") if ($loglvl > 5);
		next;
	}
	open (TMP, ">$tmp/$patchfile");
	if ($Patches{$pname}) {
		print TMP "
This is an official patch for $system version $version, please apply it.
The highest patch I have for that version of $system is #$maxnum.";
	} else {
		print TMP "
The latest patch for $system version $version is #$maxnum.";
	}
	print TMP "

-- mailpatch speaking for $cf'user

";
	close TMP;
	system "$append <$patchfile$extent >>$tmp/$patchfile";
	do add_log("copied file $patchfile into $tmp") if ($loglvl > 17);
}

if ($#numbers > 0) {
	$subject = $#numbers + 1;		# Array count starts at 0
	$subject = "$system $version, $subject patches";
} else {
	$subject = "$system $version patch #$numbers[0]";
}
do sendfile($dest, $tmp, $pack, $subject);
do clean_tmp();

exit 0;		# Ok

sub clean_tmp {
	# Do not stay in the directories we are removing...
	chdir $cf'home;
	if ($tmp ne '') {
		system '/bin/rm', '-rf', $tmp;
		do add_log("removed dir $tmp") if ($loglvl > 19);
	}
	if ($Archived{$pname}) {
		system '/bin/rm', '-rf', $tmp_loc;
		do add_log("removed dir $tmp_loc") if ($loglvl > 19);
	}
}

# Emergency exit with clean-up
sub abort {
	local($reason) = shift(@_);		# Why we are exiting
	do clean_tmp();
	do fatal($reason);
}

!NO!SUBS!
$grep -v '^;#' pl/fatal.pl >>mailpatch
$grep -v '^;#' pl/add_log.pl >>mailpatch
$grep -v '^;#' pl/read_conf.pl >>mailpatch
$grep -v '^;#' pl/unpack.pl >>mailpatch
$grep -v '^;#' pl/rangeargs.pl >>mailpatch
$grep -v '^;#' pl/sendfile.pl >>mailpatch
$grep -v '^;#' pl/distribs.pl >>mailpatch
chmod 755 mailpatch
$eunicefix mailpatch
