;# $Id: builtins.pl,v 2.9 92/07/14 16:49:38 ram Exp $
;#
;#  Copyright (c) 1992, Raphael Manfredi
;#
;#  You may redistribute only under the terms of the GNU General Public
;#  Licence as specified in the README file that comes with dist.
;#
;# $Log:	builtins.pl,v $
;# Revision 2.9  92/07/14  16:49:38  ram
;# 3.0 beta baseline.
;# 
;# 
#
# Executing builtin commands
#

# Send a receipt
sub send_receipt {
	local($subj) =			$Header{'Subject'};
	local($msg_id) =		$Header{'Message-Id'};
	local($from) =			$Header{'From'};
	local($sender) =		$Header{'Reply-To'};
	local($to) =			$Header{'To'};
	local($ack_dest) = @_;	# Were to send receipt
	local($dest);			# Return path to be used (derived from mail)

	# If no @PATH directive was found, use $sender as a return path
	$dest = $Userpath;				# Set by an @PATH
	$dest = $sender unless $dest;
	# Remove the <> if any (e.g. path derived from Return-Path)
	$dest =~ /<(.*)>/ && ($dest = $1);

	# Derive a correct return path for receipt
	$ack_dest = 'PATH' if $ack_dest eq '-';
	$ack_dest = "" if $ack_dest =~ /[=\$^&*([{}`\\|;><?]/;
	$ack_dest = $dest if ($ack_dest eq '' || $ack_dest =~ /PATH/);

	# Compute host name (fully qualified, i.e. with domain name)
	chop($hostname = `$phostname`);
	$hostname .= $mydomain if $hostname =~ /^\w+$/;

	chop($date = `date`);
	open(MAILER,"|/usr/lib/sendmail -odq -t");
	print MAILER
"To: $ack_dest
Subject: Re: $subj (receipt)
X-Mailer: mailagent [version $mversion PL$patchlevel]
";
	if ($msg_id ne '') {
		print MAILER "\nYour message $msg_id,\n";
	} else {
		print MAILER "\nYour message ";
	}
	print MAILER "addressed to $to,\n" if $to ne '';
	print MAILER "whose subject was \"$subj\",\n" if $subj ne '';
	print MAILER
"has been received by $hostname on $date

-- mailagent speaking for $cf'user
";
	close MAILER;
	if ($?) {
		do add_log("ERROR couldn't send receipt to $ack_dest") if $loglvl > 0;
	} else {
		do add_log("SENT receipt to $ack_dest") if $loglvl > 2;
	}
}

#
# Deal with builtins
#

# Built-in commands are listed herein. Those commands being built-in are always
# dealt with during mail parsing and are taken care of at the beginning of the
# rules analysis. The code to be executed for each builtin is stored in the
# Builtcode array by those routines.
sub init_builtins {
	%Builtin = (
		'RR', 'builtin_rr',
		'PATH', 'builtin_path'
	);
	undef @Builtcode;
}

# Whenever a builtin command is recognized (on the fly) while parsing the mail
# body, the corresponding builtin function is called with the remaining of the
# line given as argument (leading spaces removed).

# The @RR command asks for a receipt
sub builtin_rr {
	local($_) = @_;
	do add_log("found an @RR request to $_") if $loglvl > 18;
	# @RR request honored only if not from special user and directed to us
	unless (&special_user) {
		push(@Builtcode, "do send_receipt('$_')");
	} else {
		&add_log("ignoring @RR request to $_") if $loglvl > 4;
	}
}

# The @PATH command sets a valid return path (recorded in $Userpath)
sub builtin_path {
	local($_) = @_;
	return if /[=\$^&*([{}`\\|;><?]/;		# Invalid character found
	$Userpath = $_;
	do add_log("found an @PATH request to $_") if $loglvl > 18;
}

# Execute stacked builtins
sub run_builtins {
	return if $#Builtcode < 0;		# No recorded builtins
	foreach (@Builtcode) {
		eval($_);					# Execute stacked builtin
	}
	@Builtcode = ();				# Reset builtcode array
}

