;# $Id: pqueue.pl,v 2.9 92/07/14 16:50:32 ram Exp $
;#
;#  Copyright (c) 1992, Raphael Manfredi
;#
;#  You may redistribute only under the terms of the GNU General Public
;#  Licence as specified in the README file that comes with dist.
;#
;# $Log:	pqueue.pl,v $
;# Revision 2.9  92/07/14  16:50:32  ram
;# 3.0 beta baseline.
;# 
;# 
# Process the queue
sub pqueue {
	local($length);						# Length of message, in bytes
	undef %waiting;						# Reset waiting array
	local(@files) = <$cf'queue/fm*>;
	# The qm files are put there by the filter and left in case of error
	# Only files older than 30 minutes are re-parsed (because otherwise it
	# might have just been queued by the filter).
	local(@filter_files) = <$cf'queue/qm*>;
	foreach $file (@filter_files) {
		($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
			$atime,$mtime,$ctime,$blksize,$blocks) = stat($file);
		if ((time - $mtime) > 1800) {
			# More than 30 minutes -- there must have been a failure
			push(@files, $file);		# Add file to the to-be-parsed list
		}
	}
	# In $agent_wait are stored the names of the mails outside the queue
	# directory, waiting to be processed.
	if (-f "$cf'queue/$agent_wait") {
		if (open(WAITING, "$cf'queue/$agent_wait")) {
			while (<WAITING>) {
				chop;
				push(@files, $_);		# Process this file too
				$waiting{$_} = 1;		# Record it comes from waiting file
			}
			close WAITING;
		} else {
			&add_log("ERROR cannot open $cf'queue/$agent_wait: $!") if $loglvl;
		}
	}
	return 0 unless $#files >= 0;
	do add_log("processing the whole queue") if $loglvl > 11;
	$processed = 0;
	foreach $file (@files) {
		do add_log("dealing with $file") if $loglvl > 19;
		$file_name = $file;
		if ($waiting{$file} && ! -f "$file") {
			# We may have already processed this file without having resynced
			# agent_wait or the file has been removed.
			do add_log ("WARNING could not find $file") if $loglvl > 4;
			$waiting{$file} = 0;	# Mark it as processed
			next;					# And skip it
		}
		if (0 == &analyze_mail($file_name)) {
			unlink $file;
			++$processed;
			$waiting{$file} = 0 if $waiting{$file};
			$file =~ s|.*/(.*)|$1|;	# Keep only basename
			$length = $Header{'Length'};
			do add_log("FILTERED [$file] $length bytes") if $loglvl > 4;
		} else {
			$file =~ s|.*/(.*)|$1|;	# Keep only basename
			do add_log("ERROR leaving [$file] in queue") if $loglvl > 0;
			unlink $lockfile;
			do resync();			# Resynchronize waiting file
			exit 0;					# Do not continue now
		}
	}
	if ($processed == 0) {
		do add_log("was unable to process queue") if ($loglvl > 5);
	}
	do resync();		# Resynchronize waiting file
	$processed;			# Return the number of files processed
}

