;# $Id: rangeargs.pl,v 2.9 92/07/14 16:50:36 ram Exp $
;#
;#  Copyright (c) 1991, Raphael Manfredi
;#
;#  You may redistribute only under the terms of the GNU General Public
;#  Licence as specified in the README file that comes with dist.
;#
;# $Log:	rangeargs.pl,v $
;# Revision 2.9  92/07/14  16:50:36  ram
;# 3.0 beta baseline.
;# 
;#
# Expand a patch list
sub rangeargs {
	local(@val);
	local($maxspec) = shift;	# maximum patch value
	local($args) = $#_;			# number of parameters

	while ($args-- >= 0) {
		$_ = shift;		# first value remaining in @_
		while (/./) {
			if (s/^(\d+)-(\d+)//) {
				$min = $1;
				$max = $2;
			} elsif (s/^(\d+)-//) {
				$min = $1;
				$max = $maxspec;
			} elsif (s/^-(\d+)//) {
				$max = $1;
				$min = 1;
			} elsif (s/^(\d+)//) {
				$max = $min = $1;
			} elsif (s/^,//) {
				$min = 1;
				$max = 0;	# won't print anything
			} else {
				# error in format: skip char
				s/.//;
			}
			for ($i = $min; $i <= $max; ++$i) {
				push(@val, $i) unless $wanted{$i};	# record only once
				$wanted{$i} = 1;
			}
		}
	}
	join(' ', @val);
}

