# Basic mailagent test: ensure it is correctly invoked by filter.
do '../pl/init.pl';
do '../pl/logfile.pl';
$user = $ENV{'USER'};
chdir '../out' || exit 0;
# Make sure we'll find the mailagent
system 'perl', '-i', '-p', '-e', 's|^path.*|path     :.:../..|', '.mailagent';
$? == 0 || print "1\n";
open(RULES, ">.rules") || print "2\n";
print RULES "{ DELETE };\n";
close RULES;
open(FILTER, "|$filter -t >/dev/null 2>&1") || print "3\n";
print FILTER <<EOF;
From: test

Dummy body
EOF
close FILTER;
$? == 0 || print "4\n";
&get_log(5);
&check_log('WARNING.*assuming', 6);		# No To: field
&check_log('FILTERED', 7);				# Mail filtered
&check_log('DELETED', 8);				# Mail deleted by only rule
@files = <queue/qm*>;
@files == 0 || print "9\n";				# Queued mail deleted when filtered
unlink 'agentlog', '.rules';
sleep 1 while -f 'perl.lock';			# Let background mailagent die
# Check empty rules...
open(FILTER, "|$filter -t >/dev/null 2>&1") || print "10\n";
print FILTER <<EOF;
From: test

Dummy body
EOF
close FILTER;
$? == 0 || print "11\n";
&get_log(12);
&check_log('FILTERED', 13);				# Mail filtered
&check_log('LEFT', 14);					# Mail left in mbox
&check_log('building default', 15);		# Used default rules
-s "$user" || print "16\n";				# Maildrop is here, so is mbox
@files = <queue/qm*>;
@files == 0 || print "17\n";			# Queued mail deleted when filtered
-f 'context' && print "18\n";			# Empty context must be deleted
unlink 'agentlog', "$user";
sleep 1 while -f 'perl.lock';			# Let background mailagent die
# Make sure file is correctly queued when another mailagent is running
`cp /dev/null perl.lock`;
$? == 0 || print "19\n";
open(FILTER, "|$filter -t >/dev/null 2>&1") || print "20\n";
print FILTER <<EOF;
Dummy mail
EOF
close FILTER;
$? == 0 || print "21\n";	# Must terminate correctly (queued)
&get_log(22);
&check_log('QUEUED', 23);	# Mail was queued
$file = <queue/fm*>;
-f "$file" || print "24\n";	# Must have been left in queue as a 'fm' file
unlink "$file", 'agentlog', 'perl.lock';
print "0\n";
